# Security Policy

If a vulnerability does not compromise users' privacy or security, open a [regular GitHub issue](https://github.com/zkSNACKs/WalletWasabi/issues/new/choose).
If it does, then pay great care to responsible disclosure. Report a [private vulnerability on GitHub](https://github.com/zkSNACKs/WalletWasabi/security/advisories/new) or send an email to molnardavid84@gmail.com, preferably using PGP encryption: `F079 0C08 68BD BAB8 EE33 F9CE 50FB 7FEB 00F9 7588`

```
-----BEGIN PGP PUBLIC KEY BLOCK-----
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=QePN
-----END PGP PUBLIC KEY BLOCK-----
```
